Attribute VB_Name = "Schriftfeld"
Option Explicit
'Programm zur Ermittlung der Anzeigemastbe
'(c) Event Engineering Jrgen Pisarz Berlin 2003

Private Function FormatScale(ByVal S As Double) As String
  If S >= 1 Then
    FormatScale = Format(S, "0") + ":1"
  Else
    FormatScale = "1:" + Format(1 / S, "0")
  End If
End Function

Private Function GetScale(ByVal oSheet As Sheet) As String

Dim I, J, K As Integer
Dim dMainScale As Double
Dim dTestScale As Double
Dim dSiteScale(10) As Double
Dim sText As String


  'Standard Ergebnis
  GetScale = ""
  'Kein View, kein Text
  If oSheet.DrawingViews.Count = 0 Then Exit Function

  'erster Mastab
  dMainScale = oSheet.DrawingViews(1).Scale
  
  'Ermittle weitere Ansichten
  J = 0
  For I = 1 To oSheet.DrawingViews.Count
    'Ermittle weitere Mastbe
    dTestScale = oSheet.DrawingViews(I).Scale
    'Prfe, ob gleich hauptmastab
    If dTestScale <> dMainScale Then
      'Prfe, ob schon als Nebenmastab vorhanden
      If J > 0 Then
        For K = 0 To J
          If dTestScale = dSiteScale(K) Then
            dTestScale = 0
            Exit For
          End If
        Next K
      End If
      If dTestScale <> 0 Then
        'Nimm in die Liste auf
        dSiteScale(J) = dTestScale
        J = J + 1
        'Die liste ist begrenzt...
        If J = 11 Then Exit For
      End If
    End If
  Next I
  
  'Erstelle Zeichenfolge
  sText = FormatScale(dMainScale)
  If J > 0 Then
    sText = sText + " ("
    For I = 0 To J - 1
      If I > 0 Then
        sText = sText + " "
      End If
      sText = sText + FormatScale(dSiteScale(I))
    Next I
    sText = sText + ")"
  End If

  'Ergebnis
  GetScale = sText
  
End Function
Private Sub UpdateScale(ByVal oSheet)

Dim sText As String
Dim bHasTitleBlock As Boolean
Dim oTextBox As TextBox
    
    'Ist Titelblock vorhanden?
    bHasTitleBlock = False
    On Error Resume Next
    bHasTitleBlock = (oSheet.TitleBlock.Location = oSheet.TitleBlock.Location)
    On Error GoTo 0
    
    If bHasTitleBlock Then
      'Hat Titleblock ein Prompt-Feld Mastab?
      For Each oTextBox In oSheet.TitleBlock.Definition.Sketch.TextBoxes
        If InStr(oTextBox.FormattedText, "<Prompt>Mastab</Prompt>") > 0 Then
          'Gefunden: Hole Mastab
          sText = GetScale(oSheet)
          'Fge ein
          oSheet.TitleBlock.SetPromptResultText oTextBox, sText
          Exit For
        End If
      Next
    End If

End Sub
Sub AutoSave_Scale()

Dim oSheet As Sheet

  'Prfe Dokumenttyp
  If ThisApplication.ActiveDocumentType <> kDrawingDocumentObject Then Exit Sub
  'Gehe durch alle Sheets
  For Each oSheet In ThisApplication.ActiveDocument.Sheets
    'mache es
    UpdateScale oSheet
  Next
End Sub


Sub Mastab()
  'Prfe Dokumenttyp
  If ThisApplication.ActiveDocumentType <> kDrawingDocumentObject Then Exit Sub
  'Das Aktuelle Sheet
  UpdateScale ThisApplication.ActiveDocument.ActiveSheet
End Sub





